/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.common;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;


/**
 * This class supplies a method for the conversion of
 * one Hashtable in one HashMap.
 *
 * @version  $Id: HashtableTools.java,v 1.4 2007/01/11 19:21:40 nichele Exp $
 *
 */

public class HashtableTools {


    // -----------------------------------------------------------Public methods

    /**
     * Convert the given Hashtable in an HashMap.
     * @param hashtable the Hashtable to convert.
     * @return a HashMap containing all the elements in the Hashtable
     */
    public static HashMap hashtable2hashMap(Hashtable hashtable) {
        HashMap map = null;
        if (hashtable == null) {
            return map;
        }
        map = new HashMap();
        Enumeration enumKeys = hashtable.keys();
        Object key = null;
        while (enumKeys.hasMoreElements()) {
            key = enumKeys.nextElement();
            map.put(key, hashtable.get(key));
        }
        return map;
    }
}
