/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.common;

import java.util.Vector;

public class VectorTools {

    /**
     * Adds all elements of the second vector to the first vector
     * @param v1
     * @param v2
     */
    public static void add(Vector v1, Vector v2) {
        int numElements = v2.size();
        for (int i=0; i<numElements; i++) {
            v1.addElement(v2.elementAt(i));
        }
    }

    /**
     * Adds all elements of the object array to the first vector
     * @param v
     * @param a
     */
    public static void add(Vector v, Object[] a) {
        for (int i=0; i<a.length; i++) {
            v.addElement(a[i]);
        }
    }

    /**
     * Returns the content of the given vector as an array of String
     *
     * @param v the vector to convert - NULL = empty vector
     *
     * @return a String[] with the content of the vector
     */
    public static String[] toStringArray(Vector v) {
        if (v == null) {
            return new String[0];
        }

        String[] ret = new String[v.size()];

        for (int i=0; i<ret.length; ++i) {
            ret[i] = (String)v.elementAt(i);
        }

        return ret;
    }
}
