/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.spap.launcher;

import com.funambol.syncclient.spap.AssetInstallationException;
import com.funambol.syncclient.spap.installer.InstallationContext;

/**
 * This interface models a generic class to be able to execute
 *  a specific programs category.
 *
 * @version  $Id: Launcher.java,v 1.4 2007/01/11 19:21:40 nichele Exp $
 *
 */

public interface Launcher {

    /**
     * Executes the specified <i>programName</i> in
     * the given <i>workingDirectory</i>.
     * @param programName the program to execute.
     * @param install <code>true</code> if the program is the installation program,
     *  <code>false</code> if the program is the uninstallation program
     * @param ctx installation context information
     *
     * @throws AssetInstallationException if an error occurs during execution.
     */
    public int execute(String programName, boolean install, InstallationContext ctx)
            throws AssetInstallationException;
}