/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.spds;

import java.util.Vector;

import com.funambol.syncclient.sps.common.*;


/**
 * This class provide methods about
 * control timestamp and modificationType
 * $Id: SyncRecordFunction.java,v 1.4 2007/01/11 19:21:40 nichele Exp $
 */
public class SyncRecordFunction {


    /**
     * set timestamp
     * @param record
     * @param timestamp
     **/
    public static void setTimestamp(Record record, String timestamp) {

        Vector values = null;
        values = new Vector();

        values.addElement(timestamp);

        record.setRecordField("timestamp", values);
    }



    /**
     * set modificationType
     * @param record
     * @param modificationType
     **/
    public static void setModificationType(Record record, String modificationType) {

        Vector values = null;
        values = new Vector();

        values.addElement(modificationType);

        record.setRecordField("mtype", values);
    }



    /**
     * @param record
     * @return timestamp
     **/
    public static String getTimestamp(Record record) {

        Vector values = null;

        values = record.getRecordField("timestamp");

        return (String) values.elementAt(0);
    }
    
    /**
     * @param record
     * @return modificationType
     **/
    public static String getModificationType(Record record) {

        Vector values = null;

        values = record.getRecordField("mtype");

        return (String) values.elementAt(0);

    }



    /**
     * @param record
     * @return timestamp field position, <p>-1</p> if timestamp field not present
     **/
    public static int getPositionTimestampField(Record record) {

        Vector positions = null;

        RecordMetadata recordMetadata = null;

        recordMetadata = record.getDataStore().getRecordMetadata();

        positions = recordMetadata.getRecordFieldPosition("timestamp");

        if (positions.size() > 0) {
            return Integer.parseInt(String.valueOf(positions.elementAt(0)));
        } else {
            return -1;
        }

    }



    /**
     * @param record
     * @return modificationType field position, <p>-1</p> if timestamp field not present
     **/
    public static int getPositionModificationTypeField(Record record) {

        Vector positions = null;

        RecordMetadata recordMetadata = null;

        recordMetadata = record.getDataStore().getRecordMetadata();

        positions = recordMetadata.getRecordFieldPosition("mtype");

        if (positions.size() > 0) {
            return Integer.parseInt(String.valueOf(positions.elementAt(0)));
        } else {
            return -1;
        }

    }


    /**
     * @param record
     * @return number of operation fields
     **/
    public static int getNumberOperationFields(Record record) {

        int numberOperationFields = 0;

        Vector positions = null;

        RecordMetadata recordMetadata = null;

        recordMetadata = record.getDataStore().getRecordMetadata();

        positions = recordMetadata.getRecordFieldPosition("key");

        if (positions.size()>0) {
            numberOperationFields = positions.size();
        }

        positions = recordMetadata.getRecordFieldPosition("timestamp");

        if (positions.size()>0) {
            numberOperationFields = numberOperationFields + positions.size();
        }

        positions = recordMetadata.getRecordFieldPosition("mtype");

        if (positions.size()>0) {
            numberOperationFields = numberOperationFields + positions.size();
        }

        return numberOperationFields;

    }
    
    /**
     * @param recordMetadata
     *
     * @return the key field position
     */
    public static int getKeyFieldPosition(RecordMetadata recordMetadata) {
        Vector positions = null;

        positions = recordMetadata.getRecordFieldPosition("key");

        if (positions.size() > 0) {
            return Integer.parseInt(String.valueOf(positions.elementAt(0)));
        } else {
            return -1;
        }
    }
    
     /**
     * @param recordMetadata
     *
     * @return the key field position
     */
    public static int getModificationTypeFieldPosition(RecordMetadata recordMetadata) {
        Vector positions = null;

        positions = recordMetadata.getRecordFieldPosition("mtype");

        if (positions.size() > 0) {
            return Integer.parseInt(String.valueOf(positions.elementAt(0)));
        } else {
            return -1;
        }
    }

}