/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package com.funambol.syncclient.spds;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

/**
 * This class create progress bar
 * to display data update state
 *
 *
 * $Id: UpdateProgressBar.java,v 1.5 2007/01/11 19:21:40 nichele Exp $
 */
public class UpdateProgressBar extends Dialog {

    //----------------------------------------------------------- Constants

    private static int WIDTH = 240;
    private static int HEIGHT = 80;

    //----------------------------------------------------------- Private Data

    private Dimension dim = null;

    private JPanel barPanel = new JPanel();
    private JProgressBar progressBar = new JProgressBar();
    private JLabel labelProgressBar = new JLabel();

    //----------------------------------------------------------- Constructor


    public UpdateProgressBar(Frame parent, int maximum, String applicationName) {

        super(parent);

        labelProgressBar = new JLabel();

        progressBar.setOrientation(JProgressBar.HORIZONTAL);

        progressBar.setMinimum(0);
        progressBar.setMaximum(maximum);

        barPanel.add(labelProgressBar);
        barPanel.add(progressBar);

        this.add("Center",barPanel);
        this.setSize(WIDTH,HEIGHT);
        dim = getToolkit().getScreenSize();
        this.setLocation(dim.width/2 - getWidth()/2, dim.height/2 - getHeight()/2);
        this.setBackground(Color.darkGray);
        this.setTitle(applicationName);

    }

    //----------------------------------------------------------- Public methods

    public void setValue(int value) {
       progressBar.setValue(value);
    }

    public void close(int value) {
       this.setVisible(false);

    }

    public void Display(String dataStoreName) {

        //new line for all dataStoreName length
        if (dataStoreName.length() < 6) {
            dataStoreName = dataStoreName + "    ";
        }

        this.labelProgressBar.setText("Update: " + dataStoreName);

        this.setVisible(true);

    }


}
