/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.spds;

import java.io.IOException;

/**
 * Implement send / receive message in XML format by HttpConnection.
 *
 * The charSet is specified with the system property
 * <code>spds.charset</code>;
 * if <code>DEFAULT</code> value, the default charSet value is taken.<br>
 * if no value, the default charSet API <code>UTF-8</vode> value is taken.
 *
 *
 *
 * @version $Id: XMLSyncMLClient.java,v 1.4 2007/01/11 19:21:40 nichele Exp $
 *
 */
public class XMLSyncMLClient
extends BaseSyncMLClient
implements SyncMLClient {

    // --------------------------------------------------------------- Constants

    // --------------------------------------------------------------- Private data

    // --------------------------------------------------------------- Properties

    // --------------------------------------------------------------- Public methods

    public String sendMessage(String msg)
    throws IOException {
        return sendMessage(msg, "UTF-8");
    }

    public String sendMessage(String msg, String charSet)
    throws IOException {
        return new String(sendMessage(msg.getBytes(charSet)));
    }

}
