/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.spds.event;

/**
 * Is used to notify
 * for the principal states.
 *
 *
 *
 * @version $Id: SyncListener.java,v 1.4 2007/01/11 19:21:41 nichele Exp $
 */
public interface SyncListener {

    /**
     * The synchronization process start
     *
     * @param event
     */
    public void syncBegin(SyncEvent event) ;

    /**
     * The synchronization process end
     *
     * @param event
     */
    public void syncEnd(SyncEvent event) ;

    /**
     * Send initialization message
     *
     * @param event
     */
    public void sendInitialization(SyncEvent event) ;

    /**
     * Send modification message
     *
     * @param event
     */
    public void sendModification(SyncEvent event) ;

    /**
     * Send finalization message
     *
     * @param event
     */
    public void sendFinalization(SyncEvent event) ;

    /**
     * A no blocking error occours
     *
     * @param event
     */
    public void syncError(SyncEvent event) ;

}
