/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.sps.common;

/**
 * This class represents metadata information about a DataStore
 *
 * 
 * @version $Id: DataStoreMetadata.java,v 1.4 2007/01/11 19:21:41 nichele Exp $
 */

public class DataStoreMetadata {

    // -------------------------------------------------------------- Properties

    private String name = null;

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    private String displayName = null;

    public String getDisplayName() {
        return this.displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    private String[] syncModes;

    public String[] getSyncModes() {
        return this.syncModes;
    }

    public void setSyncModes(String[] syncModes) {
        this.syncModes = syncModes;
    }

    private String defaultSync;

    public String getDefaultSync() {
        return this.defaultSync;
    }

    public void setDefaultSync(String defaultSync) {
        this.defaultSync = defaultSync;
    }

    /**
     * Does the database require sorting via software (it does not support
     * sorting on the physical device)?
     */
    boolean softSort = false;

    public boolean isSoftSort() {
        return this.softSort;
    }

    public void setSoftSort(boolean softSort) {
        this.softSort = softSort;
    }

    private String storeVolume;

    public String getStoreVolume() {
        return this.storeVolume;
    }

    public void setStoreVolume(String storeVolume) {
        this.storeVolume = storeVolume;
    }

    //------------------------------------------------------------- Constructors

    public DataStoreMetadata (String name) {
        this.name = name;
    }

    // ---------------------------------------------------------- Public methods

    /**
     * Returns the display name
     *
     * @return this application's display name
     */
    public String toString() {
        return getDisplayName();
    }

    //---------------------------------------------------------- Private methods

}
