/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.sps.common;

import java.util.Hashtable;

/**
 * This class create FieldMetadata
 *
 *
 * $Id: FieldMetadata.java,v 1.4 2007/01/11 19:21:41 nichele Exp $
 */
public abstract class FieldMetadata {

    //-------------------------------------------------------------- Private data

    private String fieldName = null;
    private String fieldType = null;

    private Hashtable fieldAttributes = new Hashtable();

    //------------------------------------------------------------- Constructors

    public FieldMetadata(String fieldName, String fieldType, Hashtable fieldAttributes) throws DatabaseException {

        this.fieldName       = fieldName       ;
        this.fieldType       = fieldType       ;
        this.fieldAttributes = fieldAttributes ;

        if(!validateAttributes(fieldName, fieldType, fieldAttributes)) {

            throw new DatabaseException("Error in fieldAttributes");

        }

    }

    //----------------------------------------------------------- Public methods

    /**
     * @return fieldName
     **/
    public String getName() {
        return this.fieldName;
    }

    /**
     * @return fieldType
     **/
    public String getType() {
        return this.fieldType;

    }

    /**
     * @return fieldAttributes
     **/
    public Hashtable getAttributes() {
        return this.fieldAttributes;
    }

    /**
     * validate fieldAttributes
     *
     * @param fieldName
     * @param fieldType
     * @param fieldAttributes
     **/

    public abstract boolean validateAttributes(String    fieldName       ,
                                               String    fieldType       ,
                                               Hashtable fieldAttributes );

}
