/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.sps.common;

import java.util.Vector;

/**
 * This class create RecordMetadata
 *
 *
 * $Id: RecordMetadata.java,v 1.4 2007/01/11 19:21:41 nichele Exp $
 */
public class RecordMetadata {

    //-------------------------------------------------------------- Private data

    private FieldMetadata[] fieldMetadata;

    //------------------------------------------------------------- Constructors

    public RecordMetadata(FieldMetadata[] fieldMetadata) {
        this.fieldMetadata = fieldMetadata;
    }

    //----------------------------------------------------------- Public methods

    /**
     * @return fieldMetadata
     **/
    public FieldMetadata[] getFieldMetadata() {
        return this.fieldMetadata;
    }

    /**
     * @param searchFunction
     * @return record position about field with set searchFunction
     **/
    public Vector getRecordFieldPosition(String searchFunction) {


        String function = null;
        Vector positions = null;


        positions = new Vector();

        for (int i=0; i < this.getFieldMetadata().length; i++) {

            function = (String) this.getFieldMetadata()[i].getAttributes().get("function");

            if (function.equals(searchFunction)) {
                positions.addElement(new Integer(i + 1));
            }

        }

        return positions;

    }

}
