/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.syncclient.sps.jdbc;

import java.util.Hashtable;

import com.funambol.syncclient.sps.common.*;


/**
 * This class implements FieldMetadata methods
 *
 *
 * $Id: FieldMetadataImpl.java,v 1.4 2007/01/11 19:21:41 nichele Exp $
 */
public class FieldMetadataImpl extends FieldMetadata {

    //------------------------------------------------------------- Constructors

    public FieldMetadataImpl(String fieldName, String fieldType, Hashtable fieldAttributes) throws  DatabaseException{
        super(fieldName, fieldType, fieldAttributes);
    }

    int size = 0;

    /**
     * validate fieldAttributes
     *
     * @param fieldName field name
     * @param fieldType field Type
     * @param fieldAttributes field attributes
     * @return <code>true</code> if fieldAttributes are correct
     *        <code>false</code> in other case
     **/
    public boolean validateAttributes(String fieldName, String fieldType, Hashtable fieldAttributes) {

    boolean test = true;

    if (!(fieldName != null) || !(fieldType != null) || !(fieldAttributes.get("size") != null)) {
        test = false;
    }

    if ((fieldType != "String") && (fieldType != "Int")) {
        test = false;
    }

    try {
        size = Integer.parseInt((String) fieldAttributes.get("size"));
    } catch (NumberFormatException e) {
        test = false;
    }

    return test;

    }

}
