/**
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.funambol.syncclient.sps.pocketpc.util;

import com.funambol.syncclient.sps.pocketpc.RapiDB;

/**
 * This class exports a Windows CE database into a CSV file. Volume and database
 * names are passed on the command line.
 *
 * @version $Id: CEDatabaseExport.java,v 1.4 2007/01/11 19:21:41 nichele Exp $
 */
public class CEDatabaseExport {


    /**
     * Syntax:
     *  com.funambol.syncclient.sps.common.util.CEDatabaseExport volume database key_field status_field
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        if (args.length != 4) {
            syntax(args);
            System.exit(-1);
        }

        RapiDB db = new RapiDB(args[0], args[1]);
        int keyField    = 1;
        int statusField = 2;

        keyField = Integer.parseInt(args[2]);
        statusField = Integer.parseInt(args[3]);

        if (db.openDB(keyField, statusField, keyField) == false) {
            System.out.println("Error opening the database!");
            System.exit(-1);
        }

        Object[][] data = db.getAllRecords();

        for(int i=0; i<data.length; ++i) {
            System.out.print(data[i][keyField-1]);
            for (int j=0; j<data[i].length; ++j) {
                System.out.print(" , " + data[i][j]);
            }
            System.out.println("");
        }
    }

    private static void syntax(String[] args) {
        System.out.println("Wrong syntax.");
        System.out.println("Syntax:");
        System.out.println("com.funambol.syncclient.sps.common.util.CEDatabaseExport volume database key_field status_field\n");
        System.out.println("Provided args:");
        for (int i=0; i< args.length; ++i) {
            System.out.println(args[i]);
        }
    }

}
